<template>
  <div class="create-edit-promo">
    <modal :header="'Промокод'" :width="'800'" :isShow="showCreateModal" v-if="showCreateModal" @close="closeComponent">
      <div slot="body">
        <div class="single-line-input">
          <div class="form-group">
            <label for="code">Код</label>
            <input type="text" class="main-input" :class="{'invalid': checkRequired(activePromo.code)}" v-model="activePromo.code" name="code" autocomplete="off">
          </div>

          <div class="form-group">
            <label for="discount">Скидка</label>
            <input type="number" class="main-input" :class="{'invalid': checkRequired(activePromo.discount)}" v-model="activePromo.discount" name="discount" autocomplete="off">
          </div>
        </div>

        <div class="single-line-input">
          <div class="form-group">
            <label for="activeFrom">Действителен с</label>
            <input type="date" class="main-input" :class="{'invalid': checkRequired(activePromo.activeFrom)}" v-model="activePromo.activeFrom" name="activeFrom" autocomplete="off">
          </div>

          <div class="form-group">
            <label for="activeTo">Действителен до</label>
            <input type="date" class="main-input" :class="{'invalid': checkRequired(activePromo.activeTo)}" v-model="activePromo.activeTo" name="activeTo" autocomplete="off">
          </div>
        </div>

        <div class="form-group m-dropdown" v-click-outside="hideCategories">
          
          <label class="filter-label"><span>Категории</span></label>
          <input class="main-input" @focus="showCategories = true;" autocomplete="off" name="categories" v-model="activePromo.categories">

          <ul v-if="showCategories" class="m-dropdown-menu" >
            <li v-for="c in categories" @click.stop="setCategory(c)">{{c}} <span v-if="activePromo.categories.includes(c)" class="checked pull-right"></span></li>
          </ul>
        </div>

      </div>

      <div slot="footer">
        <button class="action-button main-button" @click="savePromo">СОХРАНИТЬ</button>
      </div>
    </modal>
  </div>
</template>
<script>
import Modal from "@/components/shared/Modal";
export default {
  data() {
    return {
      showCreateModal: false, showRequired: false, showCategories: false,
      activePromo: undefined
    }
  },
  props: {
    promo: Object,
    categories: Array
  },
  methods: {
    checkRequired(i) {
      if (Array.isArray(i)) {
        return this.showRequired && i.length < 1;
      } else {
        return this.showRequired && !i;
      }
    },
    setCategory(c) {
      if (this.activePromo.categories.includes(c)) {
        this.activePromo.categories.some((c1, ind, arr) => {
          if (c1 === c) {
            arr.splice(ind, 1);
          }
        });
      } else {
        this.activePromo.categories.push(c);
      }
    },
    hideCategories() {
      this.showCategories = false;
    },
    savePromo(e) {
      if (!this.activePromo.code || !this.activePromo.discount || !this.activePromo.activeFrom || !this.activePromo.activeTo) {
        this.showRequired = true;
        return this.error = 'Please, fill in required fields';
      } else {
        e.target.disabled = true;
        let pr;
        if (this.promo) {
          pr = this.$http.put(`${process.env.VUE_APP_BASE_URL}/promo-codes`, this.activePromo);
        } else {
          pr = this.$http.post(`${process.env.VUE_APP_BASE_URL}/promo-codes`, this.activePromo);
        }
        pr.then(resp => {
          this.$emit('promo', resp.data);
        }).catch(err => {
          console.log(err);
        });
      }
    },
    closeComponent() {
      this.activePromo = undefined;
      this.showCreateModal = false;
      this.$emit('close');
    }
  },
  components: {
    Modal
  },
  mounted() {
    if (!this.promo) {
      this.activePromo = new Promo();

      this.showCreateModal = true;
    } else {
      let editPromo = JSON.parse(JSON.stringify(this.promo));
      editPromo.categories = editPromo.categories.split(', ').filter(c => this.categories.includes(c));
      editPromo.activeFrom = this.$moment(new Date(editPromo.activeFrom)).format('YYYY-MM-DD');
      editPromo.activeTo = this.$moment(new Date(editPromo.activeTo)).format('YYYY-MM-DD');
      this.activePromo = editPromo;
      this.showCreateModal = true;
    }
  }
}

function Promo() {
  this.code = '',
  this.discount = 5,
  this.activeFrom = '',
  this.activeTo = '',
  this.categories = []
}


</script>
<style lang="scss">
  .create-edit-promo {
    font-size: 14px;
  }
  .create-edit-promo .single-line-input {
    justify-content: space-between;
    & > div {
      min-width: 49%;
    }
  }
</style>